s_atan.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for s_atan.c:

Go to the source code of this file.

## Functions

double | atan (double x)

## Variables

static const double | atanhi []
static const double | atanlo []
static const double | aT []
static const double | one = 1.0
static const double | huge = 1.0e300

## Function Documentation

## atan()

double atan | ( | double | x | ) |

Definition at line 67 of file s_atan.c.

References aT, atanhi, atanlo, fabs(), GET_HIGH_WORD, GET_LOW_WORD, huge, libm_hidden_def(), and one.

Referenced by __ieee754_atan2(), and SDL_atan().

{
double w,s1,s2,z;
int32_t ix,hx,id;
GET_HIGH_WORD(hx,x);
ix = hx&0x7fffffff;
if(ix>=0x44100000) { /* if |x| >= 2^66 */
u_int32_t low;
GET_LOW_WORD(low,x);
if(ix>0x7ff00000||
(ix==0x7ff00000&&(low!=0)))
return x+x; /* NaN */
if(hx>0) return atanhi[3]+atanlo[3];
else return -atanhi[3]-atanlo[3];
} if (ix < 0x3fdc0000) { /* |x| < 0.4375 */
if (ix < 0x3e200000) { /* |x| < 2^-29 */
if(huge+x>one) return x; /* raise inexact */
}
id = -1;
} else {
x = fabs(x);
if (ix < 0x3ff30000) { /* |x| < 1.1875 */
if (ix < 0x3fe60000) { /* 7/16 <=|x|<11/16 */
id = 0; x = (2.0*x-one)/(2.0+x);
} else { /* 11/16<=|x|< 19/16 */
id = 1; x = (x-one)/(x+one);
}
} else {
if (ix < 0x40038000) { /* |x| < 2.4375 */
id = 2; x = (x-1.5)/(one+1.5*x);
} else { /* 2.4375 <= |x| < 2^66 */
id = 3; x = -1.0/x;
}
}}
/* end of argument reduction */
z = x*x;
w = z*z;
/* break sum from i=0 to 10 aT[i]z**(i+1) into odd and even poly */
s1 = z*(aT[0]+w*(aT[2]+w*(aT[4]+w*(aT[6]+w*(aT[8]+w*aT[10])))));
s2 = w*(aT[1]+w*(aT[3]+w*(aT[5]+w*(aT[7]+w*aT[9]))));
if (id<0) return x - x*(s1+s2);
else {
z = atanhi[id] - ((x*(s1+s2) - atanlo[id]) - x);
return (hx<0)? -z:z;
}
}
aT
static const double aT[]
Definition: s_atan.c:49
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:108
id
GLuint id
Definition: SDL_opengl_glext.h:528
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
int32_t
signed int int32_t
Definition: SDL_config_windows.h:62
one
static const double one
Definition: s_atan.c:64
u_int32_t
unsigned int u_int32_t
Definition: math_private.h:31
atanhi
static const double atanhi[]
Definition: s_atan.c:35
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
s1
GLuint GLfloat GLfloat GLfloat GLfloat GLfloat GLfloat GLfloat GLfloat s1
Definition: SDL_opengl_glext.h:8583
GET_LOW_WORD
#define GET_LOW_WORD(i, d)
Definition: math_private.h:117
huge
static const double huge
Definition: s_atan.c:65
fabs
double fabs(double x)
Definition: s_fabs.c:22
atanlo
static const double atanlo[]
Definition: s_atan.c:42

## Variable Documentation

## aT

const double aT[]

static

Initial value:
= {
3.33333333333329318027e-01,
-1.99999999998764832476e-01,
1.42857142725034663711e-01,
-1.11111104054623557880e-01,
9.09088713343650656196e-02,
-7.69187620504482999495e-02,
6.66107313738753120669e-02,
-5.83357013379057348645e-02,
4.97687799461593236017e-02,
-3.65315727442169155270e-02,
1.62858201153657823623e-02,
}

Definition at line 49 of file s_atan.c.

Referenced by atan().

## atanhi

const double atanhi[]

static

Initial value:
= {
4.63647609000806093515e-01,
7.85398163397448278999e-01,
9.82793723247329054082e-01,
1.57079632679489655800e+00,
}

Definition at line 35 of file s_atan.c.

Referenced by atan().

## atanlo

const double atanlo[]

static

Initial value:
= {
2.26987774529616870924e-17,
3.06161699786838301793e-17,
1.39033110312309984516e-17,
6.12323399573676603587e-17,
}

Definition at line 42 of file s_atan.c.

Referenced by atan().

## huge

const double huge = 1.0e300

static

Definition at line 65 of file s_atan.c.

Referenced by atan().

## one

const double one = 1.0

static

Definition at line 64 of file s_atan.c.

Referenced by atan().